//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\comobj.hpp>
#pragma hdrstop

//Remove warning about non-Variant values being pased where a Variant should be passed
#pragma warn -lvc

//Make sure sysvari.h compiles successfully
#include <utilcls.h>

#define CommonWay

#include "OfficeAutomationMainFormUnit.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TfrmAutomation *frmAutomation;
//---------------------------------------------------------------------------

#ifndef CommonWay
  Procedure procAdd("Add");
  Procedure procAppShow("AppShow");
  Procedure procFileExit("FileExit");
  Procedure procFileNew("FileNew");
  Procedure procInsert("Insert");
  Procedure procInsertDateTime("InsertDateTime");
  Procedure procQuit("Quit");
  Procedure procSelect("Select");
  Procedure procTypeParagraph("TypeParagraph");
  Procedure procTypeText("TypeText");

  PropertyGet propR_Range("Range");

  PropertySet propW_ColumnWidth("ColumnWidth");
  PropertySet propW_DisplayAlerts("DisplayAlerts");
  PropertySet propW_FormulaR1C1("FormulaR1C1");
  PropertySet propW_Value("Value");
  PropertySet propW_Visible("Visible");

  Function funcActivate("Activate");
  Function funcActiveCell("ActiveCell");
  Function funcDocuments("Documents");
  Function funcSelection("Selection");
  Function funcWorkBooks("WorkBooks");
#endif

//---------------------------------------------------------------------------
__fastcall TfrmAutomation::TfrmAutomation(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnWordClick(TObject *Sender)
{
  //This way requires ComObj.Hpp to be included
  //MSWord = CreateOleObject("Word.Basic");

  //This call doesn't require any headers in itself
  MSWord = MSWord.CreateObject("Word.Basic");

#ifdef CommonWay
  //This is the standard way of calling a routine in an OLE server
  MSWord.OleProcedure("AppShow");
  MSWord.OleProcedure("FileNew");
  MSWord.OleProcedure("Insert", "Hello world at ");
  MSWord.OleProcedure("InsertDateTime", "dddd, dd MMMM yyyy");
  MSWord.OleProcedure("Insert", "\r");
#else
  //But here is another way:
  MSWord.Exec(procAppShow);
  MSWord.Exec(procFileNew);
  MSWord.Exec(procInsert << "Hello world at ");
  //MSWord.Exec(procInsertDateTime << "dddd, dd MMMM yyyy");
  MSWord.Exec(procInsertDateTime << "dddd, dd MMMM yyyy");
  procInsert.ClearArgs();
  MSWord.Exec(procInsert << "\r");
#endif
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnNoWordClick(TObject *Sender)
{
  //Should be able to say MSWord = Unassigned
  //but MS Office 97 doesn't adhere to the lifetime
  //management aspects of the MS COM spec., so...
#ifdef CommonWay
  MSWord.OleProcedure("FileExit", 2);
#else
  MSWord.Exec(procFileExit << 2);
#endif
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnWord2Click(TObject *Sender)
{
  MSWord = MSWord.CreateObject("Word.Application");

#ifdef CommonWay
  //This is the standard way of calling a routine in an OLE server
  MSWord.OlePropertySet("Visible", True);
  MSWord.OlePropertyGet("Documents").OleProcedure("Add");
  Variant Selection = MSWord.OlePropertyGet("Selection");
  Selection.OleProcedure("TypeText", WideString("Hello world at "));
  Selection.OleProcedure("InsertDateTime", "dddd, dd MMMM yyyy", False);
  Selection.OleProcedure("TypeParagraph");
#else
  //But here is another way:
  MSWord.Exec(propW_Visible << True);
  MSWord.Exec(funcDocuments).Exec(procAdd);
  Variant Selection = MSWord.Exec(funcSelection);
  Selection.Exec(procTypeText << "Hello world at ");
  Selection.Exec(procInsertDateTime << "dddd, dd MMMM yyyy" << False);
  Selection.Exec(procTypeParagraph);
#endif
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnNoWord2Click(TObject *Sender)
{
  //Should be able to say MSWord = Unassigned
  //but MS Office 97 doesn't adhere to the lifetime
  //management aspects of the MS COM spec., so...
#ifdef CommonWay
  MSWord.OleProcedure("Quit", False);
#else
  MSWord.Exec(procQuit << False);
#endif
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnWordStatsClick(TObject *Sender)
{
  lstDocStats->Items->Clear();
  //Update Word's doc stats
  MSWord.OleProcedure("DocumentStatistics");
  //Obtain Word's doc stats
  Variant DocStats = MSWord.OlePropertyGet("CurValues").OlePropertyGet("FileSummaryInfo");
  lstDocStats->Items->Add("Title: " + DocStats.OlePropertyGet("Title"));
  lstDocStats->Items->Add("Subject: " + DocStats.OlePropertyGet("Subject"));
  lstDocStats->Items->Add("Author: " + DocStats.OlePropertyGet("Author"));
  lstDocStats->Items->Add("Filename: " + DocStats.OlePropertyGet("Filename"));
  lstDocStats->Items->Add("Directory: " + DocStats.OlePropertyGet("Directory"));
  lstDocStats->Items->Add("Creation date: " + DocStats.OlePropertyGet("CreateDate"));
  lstDocStats->Items->Add("Keywords: " + DocStats.OlePropertyGet("Keywords"));
  lstDocStats->Items->Add("Comments: " + DocStats.OlePropertyGet("Comments"));
  lstDocStats->Items->Add("Pages: " + DocStats.OlePropertyGet("NumPages"));
  lstDocStats->Items->Add("Paragraphs: " + DocStats.OlePropertyGet("NumParas"));
  lstDocStats->Items->Add("Lines: " + DocStats.OlePropertyGet("NumLines"));
  lstDocStats->Items->Add("Words: " + DocStats.OlePropertyGet("NumWords"));
  lstDocStats->Items->Add("Characters: " + DocStats.OlePropertyGet("NumChars"));
  lstDocStats->Items->Add("Bytes in total: " + DocStats.OlePropertyGet("FileSize"));
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnWord2StatsClick(TObject *Sender)
{
  lstDocStats->Items->Clear();
  //Obtain Word's doc stats
  Variant DocStats = MSWord.OlePropertyGet("ActiveDocument").OlePropertyGet("BuiltInDocumentProperties");
  lstDocStats->Items->Add("Title: " + DocStats.OlePropertyGet("Item", "Title"));
  lstDocStats->Items->Add("Subject: " + DocStats.OlePropertyGet("Item", "Subject"));
  lstDocStats->Items->Add("Author: " + DocStats.OlePropertyGet("Item", "Author"));
  lstDocStats->Items->Add("Creation date: " + DocStats.OlePropertyGet("Item", "Creation Date"));
  lstDocStats->Items->Add("Keywords: " + DocStats.OlePropertyGet("Item", "Keywords"));
  lstDocStats->Items->Add("Pages: " + DocStats.OlePropertyGet("Item", "Number of pages"));
  lstDocStats->Items->Add("Paragraphs: " + DocStats.OlePropertyGet("Item", "Number of paragraphs"));
  lstDocStats->Items->Add("Lines: " + DocStats.OlePropertyGet("Item", "Number of lines"));
  lstDocStats->Items->Add("Words: " + DocStats.OlePropertyGet("Item", "Number of words"));
  lstDocStats->Items->Add("Characters: " + DocStats.OlePropertyGet("Item", "Number of characters"));
  lstDocStats->Items->Add("Characters (with spaces): " + DocStats.OlePropertyGet("Item", "Number of characters (with spaces)"));
  lstDocStats->Items->Add("Bytes in total: " + DocStats.OlePropertyGet("Item", "Number of bytes"));
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnXLClick(TObject *Sender)
{
  XL = XL.CreateObject("Excel.Application");
#ifdef CommonWay
  XL.OlePropertySet("Visible", True);
  XL.OlePropertyGet("WorkBooks").OleProcedure("Add");
  XL.OlePropertyGet("Range", "C1").OleProcedure("Select");
  XL.OlePropertyGet("ActiveCell").OlePropertySet("Value", "Hello");
  XL.OlePropertyGet("Range", "C3:D4").OleProcedure("Select");
  XL.OlePropertyGet("Range", "C4").OleProcedure("Activate");
  XL.OlePropertyGet("ActiveCell").OlePropertySet("FormulaR1C1", "=@Now()");
  XL.OlePropertyGet("ActiveCell").OlePropertySet("ColumnWidth", 15);
#else
  XL.Exec(propW_Visible << True);
  XL.Exec(funcWorkBooks).Exec(procAdd);
  XL.Exec(propR_Range << "C1").Exec(procSelect);
  XL.Exec(funcActiveCell).Exec(propW_Value << "Hello");
  propR_Range.ClearArgs();
  XL.Exec(propR_Range << "C3:D4").Exec(procSelect);
  propR_Range.ClearArgs();
  XL.Exec(propR_Range << "C4").Exec(funcActivate);
  XL.Exec(funcActiveCell).Exec(propW_FormulaR1C1 << "=@Now()");
  XL.Exec(funcActiveCell).Exec(propW_ColumnWidth << 15);
#endif
}
//---------------------------------------------------------------------------
void __fastcall TfrmAutomation::btnNoXLClick(TObject *Sender)
{
  //Should be able to say XL = Unassigned
  //but MS Office 97 doesn't adhere to the lifetime
  //management aspects of the MS COM spec., so...
#ifdef CommonWay
  XL.OlePropertySet("DisplayAlerts", False);
  XL.OleProcedure("Quit");
#else
  XL.Exec(propW_DisplayAlerts << False);
  XL.Exec(procQuit);
#endif
}
//---------------------------------------------------------------------------
